package meme;

import java.util.*;
import java.io.*;


public class FastaText {
	double [] letterFrequencies;  	//frequencies of letters
	HashMap <String,String>  text; /* p-values for this motif for each threshold value*/
	StringBuilder allText;			//all text in multifasta format
	int totalLength;				//total length of sequences
	
	public FastaText(BufferedReader br) 
	  {
		letterFrequencies = new double [4] ;
		for (int i = 0; i<4;i++) 
			  letterFrequencies[i] = 0;
				      
		 
		allText = new StringBuilder(); 
		text = new HashMap <String,String>();   
		
		String name = null;
		        
		// dis.ready() returns 0 if the buffer is empty
		try {
			while (br.ready()) {
				String s = br.readLine();
			    // this statement reads the line from the file 
			    allText.append(s+"\n");	  
			    if (s.matches(">.*")) {
			       	name = new String(s);
			        text.put(name, "");
			    }
			    else {
			        text.put(name, text.get(name)+s);
			        char [] subtext = s.toCharArray(); 
			       	for (int i = 0; i<s.length();i++) {
			        	switch (subtext[i]) {
			        	case 'a': letterFrequencies[0]++; break;
			        	case 'A': letterFrequencies[0]++; break;
			        	case 'c': letterFrequencies[1]++; break;
			        	case 'C': letterFrequencies[1]++; break;
			        	case 'g': letterFrequencies[2]++; break;
			        	case 'G': letterFrequencies[2]++; break;
			        	case 't': letterFrequencies[3]++; break;
			        	case 'T': letterFrequencies[3]++; break;
			        		
			     		}
			     	}
			   		text.put(name, text.get(name)+s);
			        			
			   	}
			 }
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}



		 totalLength = 0;
		 for (int i = 0; i<4;i++) 
		    	totalLength += letterFrequencies[i];
		 for (int i = 0; i<4;i++) 
		      	letterFrequencies[i] = letterFrequencies[i]/totalLength;
		        
		
	  }
	public FastaText(String fileName) throws FileNotFoundException
	  {
		this(new BufferedReader (new FileReader (fileName)));		
	  }	
	
	public FastaText(File file) throws FileNotFoundException
	  {		
		this(new BufferedReader(new InputStreamReader(new BufferedInputStream(new FileInputStream(file)))));			
	  }
	
	public int getNumberOfSeqs() {
		return text.size();
	}
	public Set <String> getNames() {
		
		return text.keySet();
	}
	public char[] getSeq(String seqName) {
		
		return text.get(seqName).toCharArray();
		
	}
	public double[] getLetterFreqs() {
		
		return letterFrequencies;
		
	}
	
	/* public  FastaText(File file)
	  {
		for (int i = 0; i<4;i++) 
		  letterFrequencies[i] = 0;
			      
		FileInputStream fis = null;	      
		BufferedInputStream bis = null;		      
		BufferedReader br = null;	      
		allText = new StringBuilder(); 
	      
	    try {
	        fis = new FileInputStream(file);

	        // Here BufferedInputStream is added for fast reading.
	        bis = new BufferedInputStream(fis);	        
	        br = new BufferedReader(new InputStreamReader(bis));

	        String name = null;
	        
	        
	        // dis.ready() returns 0 if the buffer is empty
	        while (br.ready()) {
	        	String s = br.readLine();
	        // this statement reads the line from the file 
	        	allText.append(s+"\n");	  
	        	if (s.matches(">.*")) {
	        		name = s;
	        		text.put(name, "");
	        	}
	        	else {
	        		text.put(name, text.get(name)+s);
	        		char [] subtext = s.toCharArray(); 
	        		for (int i = 0; i<s.length();i++) {
	        			switch (subtext[i]) {
	        			case 'a': letterFrequencies[0]++; break;
	        			case 'A': letterFrequencies[0]++; break;
	        			case 'c': letterFrequencies[1]++; break;
	        			case 'C': letterFrequencies[1]++; break;
	        			case 'g': letterFrequencies[2]++; break;
	        			case 'G': letterFrequencies[2]++; break;
	        			case 't': letterFrequencies[3]++; break;
	        			case 'T': letterFrequencies[3]++; break;
	        			
	        			}
	        		}
	        		text.put(name, text.get(name)+s);
	        			
	        	}
	        }

	        // dispose all the resources after using them.
	        fis.close();
	        bis.close();
	        br.close();

	        int totalLength = 0;
	        for (int i = 0; i<4;i++) 
	        	totalLength += letterFrequencies[i];
	        for (int i = 0; i<4;i++) 
	        	letterFrequencies[i] = letterFrequencies[i]/totalLength;
	        
	      } catch (FileNotFoundException e) {
	        e.printStackTrace();
	      } catch (IOException e) {
	        e.printStackTrace();
	      }
	  }
	  */
}
