package meme;

import java.util.*;

/* sequence sample */
public class Sample { 	
	  private int nsites;			/* number of sites of current motif */
	  List <Site> sites;	/* list of sites of current motif */
	  double pv;			/* minimum p-value of sites of current motif */	

	  public Sample() {
		  nsites = 0;
		  pv = 0;
		  sites = new ArrayList<Site>();
	  }
	  public void incrNSites() {
		  nsites++;
	  }
	  public void incrNSites(Site st) {
		  nsites++;
		  sites.add(st);
	  }
	public void calculatePvalue(int i, Double prob) {
		pv = 1-Math.pow(1-prob, i);		
	}
	public int getNumberOfSites() {
		return nsites; 
	}
	public Site siteAt (int i) {
		return sites.get(i);
	}
}
