package micsa.fun;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Hashtable;
import java.util.regex.Matcher;
import java.util.regex.Pattern;


public class DeleteRegions {
	static Hashtable <String,Hashtable<Integer,Integer>> masked = new Hashtable <String,Hashtable<Integer,Integer>>();
	static BufferedReader br = null;
	static String s;


	public static void runDeleteRegions(File genomeBlackList, File fileWithPeaks) {
		//read genomeBlackList
	    try {              
	      // Here BufferedInputStream is added for fast reading.
	      br = new BufferedReader(new FileReader(genomeBlackList));
	      Pattern pattern = Pattern.compile( ".*(chr\\S+)\\s(\\d+)\\s(\\d+).*");       
	 		//Pattern pattern = Pattern.compile( ".*(c?h?r?[0-9XYMTWZ]+)\\s\\d+\\s\\d+\\s\\d+\\s([0-9]+\\.[0-9]+).*");              
	      while ((s = br.readLine())!=null) {	  			   
				   Matcher matcher = pattern.matcher( s );					
				   if (matcher.find()) {								
					String chrom = matcher.group(1);
					chrom = chrom.replace("chr", "");
					chrom = chrom.replace("MT", "M");
					Integer start = Integer.parseInt(matcher.group(2));
					Integer end = Integer.parseInt(matcher.group(3));
					if (!masked.containsKey(chrom))
						masked.put(chrom, new Hashtable<Integer,Integer>());
					masked.get(chrom).put(start, end);
				}	  			   
			  }	
	      br.close();    
	    } catch (IOException e) {
	      e.printStackTrace();
	    }
		//read file with peaks
	    StringBuffer sb = new StringBuffer();  
	    try {
	    	br = new BufferedReader(new FileReader(fileWithPeaks));
	    	//Pattern pattern = Pattern.compile( ".*(chr\\S+)\\s(\\d+)\\s(\\d+).*");              
	    	Pattern pattern = Pattern.compile( ".*?(c?h?r?[0-9XYMTWZ]+)\\s(\\d+)\\s(\\d+)\\s\\d+\\s([0-9]+\\.[0-9]+).*");
	    	while ((s = br.readLine())!=null) {
				   //System.out.println(s); 
				   s = s.replaceAll(".fa", "");
				   Matcher matcher = pattern.matcher( s );					
				   if (matcher.find()) {								
						String chrom = matcher.group(1);
						chrom = chrom.replace("chr", "");
						chrom = chrom.replace("MT", "M");
						Integer start = Integer.parseInt(matcher.group(2));
						Integer end = Integer.parseInt(matcher.group(3));	
						boolean exclude = false;
						if (masked.containsKey(chrom)) {
							for (Integer left : masked.get(chrom).keySet()) {
								Integer right = masked.get(chrom).get(left);
								if ((left <= start)&&(right >= start))
									exclude = true;		            			
								else if ((left <= end)&&(right >= end))
			        				exclude = true;		            			
								else if ((start <= left)&&(right <= end))
			        				exclude = true;		            					
							}
						}	
						if (!exclude) {
							 sb.append(s+"\n");
						}
				   }
				   else {
					 sb.append(s+"\n");
				   }
				   
			}
			br.close();
			  //print to file with peaks
	        BufferedWriter bw = new BufferedWriter(new FileWriter(fileWithPeaks));            
	        bw.write(sb.toString()) ;		            
	        bw.close() 	;     
		} catch (NumberFormatException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}	          
	                     
	}
	public static void main(String[] args) throws IOException {
		String usage = "java -Xmx1565m Summary -f <FindPeaks output file for ChIP> -r <file with tab delimited positions of regions to mask>";
		
		if (args.length < 4) {
			System.err.println("Too few arguments\n");
			System.err.println(usage);
			System.exit(1);
		}
		
		File genomeBlackList = null;
		File fileWithPeaks = null;
	
		int currentIndex = 0;
		

		while (currentIndex<args.length) {
			//System.out.println(args[currentIndex]);	
			if (args[currentIndex].compareTo("-f")==0) {
				currentIndex++;
				fileWithPeaks = new File (args[currentIndex]);
				
			}			
			 
			else if (args[currentIndex].compareTo("-r")==0) {
				currentIndex++;
				genomeBlackList = new File (args[currentIndex]);
			}
			currentIndex++;
		}
		runDeleteRegions( genomeBlackList,  fileWithPeaks);
		
	}
}